;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Runden0
;
; Routine zum Runden zweier Linien/Polylinien mit Radius=0
;
; Aufruf: runden0
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 2.1                      Datum: 29.10.1998
; AutoCAD12   [ ]  AutoCAD14   [x]  AutoCAD2000(i) [x]   
; AutoCAD2002 [x]  AutoCAD2004 [x]  AutoCAD2005    [ ]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

(defun c:runden0 ( / p1 p2 mp enX1 enX2 en1 en2 ent1 ent2 e1p1 e1p2 e2p1 e2p2 pliste1 pliste2 dump temp i)


	;Initialisieren
	(setq sys_emode (getvar "EDGEMODE")
	      sys_pmode (getvar "PROJMODE")
	        sys_cmd (getvar "CMDECHO")
	       exitflag nil
	         rndErr *error*
	        *error* rndError
	)

	(setvar "EDGEMODE" 1)
	(setvar "PROJMODE" 1)
	(setvar "CMDECHO" 0)

	(while (not exitflag)

		(setq p1 nil p2 nil en1 nil en2 nil enX1 nil enX2 nil ent1 nil ent2 nil)
		(setq e1p1 nil e1p2 nil e2p1 nil e2p2 nil pliste1 nil pliste2 nil mp nil i nil)

		;Elemente whlen lassen:
		(setq enX1 (entsel "\nErstes Element whlen oder Return fr Ende"));nentsel????
		(if (/= enX1 nil)
		(progn
		(command "_.undo" "_begin")
		(redraw (car enX1) 3)
		(setq enX2 (entsel "\nZweites Element whlen"))
		(if (/= enX2 nil) (redraw (car enX2) 3))

		;Elemente berprfen
			(setq p1   (trans (osnap (cadr enX1) "_NEA") 1 0)
			      p2   (trans (osnap (cadr enX2) "_NEA") 1 0)
		   	   en1  (car enX1)
		      	en2  (car enX2)
			      ent1 (entget en1)
			      ent2 (entget en2)
			)

			;Abbruch wenn nicht LINE oder POLYLINE
			(if (or (not (member (cdr (assoc 0 ent1)) '("LWPOLYLINE" "LINE"))) (not (member (cdr (assoc 0 ent2)) '("LWPOLYLINE" "LINE"))))
				(progn
					(princ "\nEs knnen nur Linien oder Polylinien gerundet werden!")
					(quit)
				)
			)

			;Linienpunkte ermitteln
			(setq pliste1 (rndExtract (car enX1)))
			(setq pliste2 (rndExtract (car enX2)))
	
			;Alle Geraden von PListe1 und PListe2 berprfen
				;Element Nr. 1		
				(if (rndSearchHit (car PListe1) (cadr Pliste1) p1)
					(setq e1P1 (car PListe1) e1P2 (cadr PListe1))
					(if (rndSearchHit (caddr PListe1) (cadddr Pliste1) p1)
						(setq e1P1 (caddr PListe1) e1P2 (cadddr PListe1))
						(progn
							(princ "\nDie Wahl des ersten Elements ist ungltig (evtl. eine Kurve innerhalb einer Polylinie gewhlt)")	
							(quit)
						)
					)
				)

				;Element Nr. 2
				(if (rndSearchHit (car PListe2) (cadr Pliste2) p2)
					(setq e2P1 (car PListe2) e2P2 (cadr PListe2))
					(if (rndSearchHit (caddr PListe2) (cadddr Pliste2) p2)
						(setq e2P1 (caddr PListe2) e2P2 (cadddr PListe2))
						(progn
							(princ "\nDie Wahl des zweiten Elements ist ungltig (evtl. eine Kurve innerhalb einer Polylinie gewhlt)")
							(quit)
						)	
					)
				)

				;Mglichen Schnittpunkt ermittlen
					(if (= (setq mp (inters e1p1 e1p2 e2p1 e2p2 nil)) nil)
						(progn
							(princ "\nDie beiden Linien haben keinen gemeinsamen Schnittpunkt!")
							(quit)
						)
					)

		;Linien EXTEND
			(command "_extend" enX1 enX2 "" enX2 enX1 "")
			(setq pliste1 (rndExtract (car enX1)))
			(setq pliste2 (rndExtract (car enX2)))

		;Notwendigkeit von TRIM ermitteln und evtl. ausfhren
			;Element 1
				(if (= (rndSearchPoint pliste1 mp) nil)
					(progn
						(if (< (distance e1p1 p1) (distance e1p1 mp))
							(setq dump (list en1 e1p2))
							(setq dump (list en1 e1p1))
						)
						(command "_trim" enX2 "" dump "")
					)
				)

			;Element 2
				(if (= (rndSearchPoint pliste2 mp) nil)
					(progn
						(if (< (distance e2p1 p2) (distance e2p1 mp))
							(setq dump (list en2 e2p2))
							(setq dump (list en2 e2p1))
						)
						(command "_trim" enX1 "" dump "")
					)
				)
		(command "_.undo" "_end")
		)
		(progn
			(setq exitflag T)
		)
	)
	)

	;Ende
		(setq *error* rndErr)
		(princ "\nFertig")
		(print)
)

;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;; Routine, die aus einem Polylinienelement die Punkte einer Geraden extrahiert
;;
;; Rckgabe: Liste mit 3D-Punkten (p1 p2 p3 p4)
;;           Dabei ist p1 und p3 der Endpunkt einer (Poly-)Linie, p2/P4 die beiden
;;           Punkte um eins nach innen von P1/P3. Bei einer Linie ist gilt:
;;           P1=P3 und P2=P4 - um die Logik einzuhalten
;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
(defun rndExtract (en / i dump ergebnis ent)

	(setq flag (cdr (assoc 0 (entget en))))
	(setq ent (entget en))
	(setq ergebnis nil)

	(if (= flag "LINE")
		(progn
			(setq ergebnis (list (cdr (assoc 10 ent)) (cdr (assoc 11 ent)) (cdr (assoc 10 ent)) (cdr (assoc 11 ent))))
		)
		(if (= flag "LWPOLYLINE")
			(progn
				(setq i 1)
				(while (<= i (length ent))
					(setq temp (nth (1- i) ent))
					(if (= (car temp) 10) (setq dump (append dump (list (cdr temp)))))
					(setq i (1+ i))
				)

				(if (= (length dump) 2)
					(setq ergebnis (list (car dump) (cadr dump) (car dump) (cadr dump)))
					(progn
					(if (= (length dump) 3)
						(setq ergebnis (list (car dump) (cadr dump) (caddr dump) (cadr dump)))
						(setq ergebnis (list (car dump) (cadr dump) (car (reverse dump)) (cadr (reverse dump))))
					)
					)
				)
			)
			(progn
				(princ "\nEs knnen mit diesem Befehl nur Linien und Polylinien gerundet werden!")
				(quit)
			)
		)
	)
	ergebnis
)

;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;; Routine, die Herausfndet, ob ein Punkt (punkt) innerhalb einer Liste von
;; Punkten (pliste) vorhanden ist
;;
;; Rckgabe: T oder nil
;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
(defun rndSearchPoint (pliste punkt / ergebnis i)

	(setq i (length pliste))
	(setq ergebnis nil)

	(while (> i 0)
		(if (equal (nth (1- i) pliste) punkt) (setq ergebnis T) 0.01)
		(setq i (1- i))
	)
	ergebnis
)

;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;; Routine, die Ermittelt ob ein Punkt (p) auf einer Gerade (pl1/pl2) liegt
;;
;; Rckgabe: T oder nil
;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
(defun rndSearchHit (pl1 pl2 p / abstand winkel punkt ergebnis)

	(setq abstand (distance pl1 p)
	       winkel (angle pl1 pl2)
	        punkt (polar pl1 winkel abstand)
	       punkt2 (reverse (cdr (reverse p)))
	)
	(if (= (length punkt) 3) (setq punkt (reverse (cdr (reverse punkt)))))

	(if (equal punkt punkt2 0.0001) (setq ergebnis T) (setq ergebnis nil))
	ergebnis
)


(defun rndError ()
	(setq *error* rndErr)
	(command "_.undo" "_end")
	(setvar "EDGEMODE" sys_emode)
	(setvar "PROJMODE" sys_pmode)
	(setvar "CMDECHO" sys_cmd)

	(princ)
	(princ)
)


(princ "\nrunden0 - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: runden0")
(print)
